#ifndef Lib_RandomFromFunction_h
#define Lib_RandomFromFunction_h

namespace Slash {namespace Core {class IWriter;}}

namespace Slash {namespace Data {class IFunction;}}

namespace Lib {

class RandomFlat;

class RandomFromFunction {
public:
  RandomFromFunction(Slash::Data::IFunction&,int,double,double,Slash::Core::IWriter&);
  virtual ~RandomFromFunction();
  double shoot();
  bool isValid() const;
  bool reset(int);
  //epsilon  = 0.000001
  bool integrate(double,double,double epsilon,double&) const;
private:
  void clear();
private:
  Slash::Data::IFunction& fFunction;
  Slash::Core::IWriter& fPrinter;
  int fNpx;
  double fXmin;
  double fXmax;
  double* fIntegral;
  double* fAlpha;
  double* fBeta;
  double* fGamma;
  RandomFlat* fRandomFlat;
};

}

#endif
